<template>
  <div>
    <div
      v-if="type !== 'session'"
      class="modal__input"
      :class="{ 'is-active': newItem.name }"
    >
      <span class="modal__label">{{ $t('events.name') }}</span>
      <el-input @focus="inputFocus" v-model="newItem.name" border line />
    </div>
    <div class="modal__grid">
      <div>
        <div class="modal__input" :class="{ 'is-active': newItem.date }">
          <span class="modal__label">{{ $t('events.date') }}</span>
          <el-input
            @focus="inputFocus"
            v-model="newItem.date"
            v-mask="'##.##.####'"
            border
            line
          />
        </div>
      </div>
      <div>
        <div
          class="modal__input"
          :class="{ 'is-active': newItem.time.length > 0 }"
        >
          <span class="modal__label">{{ $t('events.time') }}</span>
          <el-input
            @focus="inputFocus"
            v-model="newItem.time"
            v-mask="'##:##'"
            border
            line
          />
        </div>
      </div>
    </div>

    <div v-if="clientData && type !== 'session'" class="modal__input">
      <span class="modal__label">{{ $t('events.client') }}</span>
      <el-autocomplete
        border
        line
        v-model="newItem.customer"
        value-key="username"
        :fetch-suggestions="querySearch"
        :trigger-on-focus="false"
        @focus="inputFocus"
        @select="handleSelect"
      >
        <template slot-scope="{ item }">
          <div style="display: flex; align-items: center; padding: 5px 0">
            <Avatar :user="item.data" :size="40" style="margin-right: 15px" />
            <div>{{ item.data.username }}</div>
          </div>
          <!-- <Clients
            :customer="item.data"
            style="padding-top: 10px; padding-bottom: 10px"
          /> -->
        </template>
      </el-autocomplete>
    </div>
    <div
      class="modal__input"
      :class="{ 'is-active': newItem.locations.length > 0 }"
      @click="modals.map = !modals.map"
    >
      <span class="modal__label">{{ $t('events.location') }}</span>
      <el-input
        @focus="inputFocus"
        border
        line
        v-model="newItem.locations"
        readonly
      />
    </div>

    <div>
      <div
        class="modal__input"
        :class="{ 'is-active': newItem.note.length > 0 }"
      >
        <span class="modal__label">{{ $t('events.note') }}</span>
        <el-input @focus="inputFocus" v-model="newItem.note" border line />
      </div>
    </div>

    <div
      v-for="(item, index) in newItem.payment"
      :key="index"
      class="modal__grid"
    >
      <div v-if="user">
        <div class="modal__input">
          <span class="modal__label">{{ $t('events.payment') }}</span>
          <el-select @focus="inputFocus" border line v-model="item.type">
            <el-option
              v-for="item in user.payment_types"
              :key="item.id"
              :value="item.payment_type"
            >
              {{ item.payment_type }}
            </el-option>
          </el-select>
        </div>
      </div>
      <div>
        <div class="modal__input">
          <span class="modal__label">{{ $t('events.price') }}</span>
          <el-input v-model="item.value" @focus="inputFocus" border line />
        </div>
      </div>
    </div>

    <AddPayment
      v-if="newItem.payment.length !== user.payment_types.length"
      @click="useAddPayment(newItem.payment)"
    />

    <Button size="medium" @click="CreateEvent">
      {{ $t('buttons.create') }}
      <svg-icon name="arrow-line" class="icon-radius" />
    </Button>

    <Map
      v-if="modals.map"
      type="edit"
      :data="newLocationGeo || user.location"
      :onCreate="onCreateLocation"
      @closeMap="modals.map = false"
    />
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  computed,
  useContext
} from '@nuxtjs/composition-api'

import {
  useGetClientsQuery,
  useCreateEventMutation,
  useCreateLocationMutation
} from '~/sdk/hooks'
import useGenerateUUID from '@/hooks/generate-uuid'
import useAddPayment from '@/hooks/add-payment'

import elInput from '@/components/element/Input.vue'
import elSelect from '@/components/element/Select.vue'
import elDatePicker from '@/components/element/DatePicker.vue'
import elTimeSelect from '@/components/element/TimeSelect.vue'
import elAutocomplete from '@/components/element/Autocomplete.vue'
import elUpload from '@/components/element/Upload.vue'

import Avatar from '@/components/ui/Avatar.vue'
import AddPayment from '@/components/ui/AddPayment.vue'
import Button from '@/components/ui/Button.vue'
import Modal from '@/components/ui/Modal.vue'
import Map from '@/components/ui/Map.vue'
import { format } from 'date-fns'

type Item = {
  id: string
  name: string | ''
  note: string | ''
  date: string
  time: string
  customerId: string | ''
  customer: string | ''
  comment: string | ''
  retouching: boolean
  upload: string
  locations: string
  location: string
  payment: any
}

export default defineComponent<{
  type: string | ''
  clientId: string | ''
}>({
  name: 'AlbumsPage',
  props: ['type', 'clientId'],
  components: {
    Avatar,
    AddPayment,
    Button,
    Modal,
    Map,
    elInput,
    elSelect,
    elDatePicker,
    elTimeSelect,
    elUpload,
    elAutocomplete
  },
  setup(props, { root }) {
    const user = computed(() => root.$accessor.auth.user)

    if (!user.value) return
    const { result: clientData } = useGetClientsQuery({
      userId: user.value.id
    })

    const newItem = ref<Item>(createItem())
    function createItem(): Item {
      const object: Item = {
        id: useGenerateUUID(),
        name: '',
        time: '',
        date: '',
        customerId: '',
        customer: '',
        comment: '',
        note: '',
        retouching: false,
        upload: '',
        location: '',
        locations: '',
        payment: [
          {
            type: '',
            value: undefined
          }
        ]
      }
      return object
    }

    const inputFocus = (event: any) => {
      event.target.closest('.modal__input').classList.add('is-active')
    }
    const querySearch = (queryString: any, cb: any) => {
      let links = clientData.value.users.map(user => ({
        username: user.username,
        data: user
      }))
      let results = queryString
        ? links.filter(createFilter(queryString))
        : links
      cb(results)
    }
    const createFilter = (queryString: any) => {
      return (link: any) => {
        return (
          link.username.toLowerCase().indexOf(queryString.toLowerCase()) === 0
        )
      }
    }
    const handleSelect = (item: any) => {
      newItem.value.customerId = item.data.id
    }

    // payment

    // map component
    const modals = ref({
      map: false
    })
    const newLocation = ref()
    const newLocationGeo = ref(null)
    const onCreateLocation = (data: any) => {
      modals.value.map = false
      newItem.value.locations = data.location_name
      newLocation.value = data
      newLocationGeo.value = data.coordinates
    }

    const { mutate: createEvent } = useCreateEventMutation({})
    const { mutate: updateGeo } = useCreateLocationMutation({})
    async function CreateEvent() {
      if (newLocation.value) {
        await updateGeo({
          object: {
            id: newLocation.value.id,
            ...newLocation.value.geo,
            geo: {
              type: 'Point',
              coordinates: newLocation.value.coordinates
            }
          }
        })
      }
      if (props.type !== 'session') {
        await createEvent({
          object: {
            id: newItem.value.id,
            name: newItem.value.name,
            date: new Date(newItem.value.date).toISOString() as any,
            user_id: root.$accessor.auth.userId as string,
            customer_id: newItem.value.customerId || '',
            location_id: newLocation.value.id || undefined
          },
          payment: newItem.value.payment.map((r: any) => ({
            event_id: newItem.value.id,
            payment_type: r.type,
            price: r.value >= 0 ? r.value : 0
          }))
        })
      } else {
        await createEvent({
          object: {
            id: newItem.value.id,
            name: '',
            retouching: newItem.value.retouching,
            date: new Date(newItem.value.date).toISOString() as any,
            user_id: root.$accessor.auth.userId as string,
            customer_id: props.clientId,
            location_id: newLocation.value.id || undefined
          },
          payment: newItem.value.payment.map((r: any) => ({
            album_id: newItem.value.id,
            payment_type: r.type,
            price: r.value >= 0 ? r.value : 0
          }))
        })
      }
    }

    return {
      user,
      CreateEvent,
      newItem,
      inputFocus,
      format,
      clientData,
      querySearch,
      handleSelect,
      modals,
      useAddPayment,
      onCreateLocation,
      newLocationGeo
    }
  }
})
</script>
